#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf openssl-0.9.7m.tar.gz
    cd openssl-0.9.7m
    sed -i -e "s/-O3/$CFLAGS -fPIC/" Configure
    ed -s Configure >/dev/null <<EOF
/^"linux-elf",/
s/-m486 //
w
q
EOF
    if [ "`uname -m`" = 'sparc' ]; then
	./Configure --prefix=/usr/local --openssldir=/usr/local/openssl \
		linux-sparcv7
    elif [ "`uname -m`" = 'sh4' ]; then
	./Configure --prefix=/usr/local --openssldir=/usr/local/openssl \
		no-asm linux-elf
    else
	./config --prefix=/usr/local --openssldir=/usr/local/openssl
    fi
    make
    sudo make install_sw
    cd ..
    rm -rf openssl-0.9.7m
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

#ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
#for CTRLFILE in */CONTROL/control; do
#    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
#    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
#done
